#!/bin/bash

INSTALL_DIR=/usr/share/netpolice

/sbin/iptables-save > $INSTALL_DIR/iptables
/sbin/iptables -t nat -A OUTPUT ! -o lo -p tcp -m tcp --dport 443 -m owner ! --uid-owner root -j REDIRECT --to-ports 8888
/sbin/iptables -t nat -A OUTPUT ! -o lo -p tcp -m tcp --dport 80 -m owner ! --uid-owner root -j REDIRECT --to-ports 8888
/sbin/iptables -A OUTPUT ! -o lo -p udp -m udp --dport 443 -j DROP

export $(awk '$1~/^UID_M(IN|AX)/{print $1"="$2}' /etc/login.defs) #'
localhomes=($(awk -F: -v UID_MIN=${UID_MIN} -v UID_MAX=${UID_MAX} '$3>=UID_MIN && $3<=UID_MAX {print $6}' < <(getent passwd)))
localusers=($(awk -F: -v UID_MIN=${UID_MIN} -v UID_MAX=${UID_MAX} '$3>=UID_MIN && $3<=UID_MAX {print $1}' < <(getent passwd)))
for i in $(seq 0 $((${#localhomes[@]}-1))); do
    chown -R ${localusers[${i}]}. /usr/share/netpolice/netpolice.crt
    mkdir -p ${localhomes[${i}]}/.pki/nssdb
    for dir in $(find ${localhomes[${i}]} -regex ".*\.mozilla/.*/cert9.db"); do
        certutil -d sql:${dir%/*} -A -t "TCu,Cuw,Tuw" -n NetPoliceCert -i /usr/share/netpolice/netpolice.crt || true
        chown -R ${localusers[${i}]}. ${dir%/*}
    done
    certutil -d sql:${localhomes[${i}]}/.pki/nssdb -A -t "C,," -n NetPoliceCert -i /usr/share/netpolice/netpolice.crt || true
    chown -R ${localusers[${i}]}. ${localhomes[${i}]}/.pki
done
